VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.2#0"; "COMCTL32.OCX"
Begin VB.Form Form1 
   Caption         =   "3D Bezier By Andrea Ingegneri (Ringraziamenti molto speciali a Gianpaolo Ingegneri)"
   ClientHeight    =   5655
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10110
   LinkTopic       =   "Form1"
   ScaleHeight     =   377
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   674
   StartUpPosition =   3  'Windows Default
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      Left            =   5040
      Max             =   180
      Min             =   -180
      TabIndex        =   13
      TabStop         =   0   'False
      Top             =   3720
      Width           =   4935
   End
   Begin VB.VScrollBar VScroll5 
      Height          =   3615
      Left            =   9720
      Max             =   180
      Min             =   -180
      TabIndex        =   12
      TabStop         =   0   'False
      Top             =   120
      Width           =   255
   End
   Begin VB.Frame Frame1 
      Caption         =   "Dettaglio"
      Height          =   1215
      Left            =   5040
      TabIndex        =   9
      Top             =   4200
      Width           =   4815
      Begin ComctlLib.Slider Slider1 
         Height          =   375
         Left            =   240
         TabIndex        =   10
         Top             =   240
         Width           =   4335
         _ExtentX        =   7646
         _ExtentY        =   661
         _Version        =   327682
         Min             =   10
         Max             =   20
         SelStart        =   10
         Value           =   10
      End
      Begin ComctlLib.Slider Slider2 
         Height          =   375
         Left            =   240
         TabIndex        =   11
         Top             =   720
         Width           =   4335
         _ExtentX        =   7646
         _ExtentY        =   661
         _Version        =   327682
         Min             =   10
         Max             =   20
         SelStart        =   10
         Value           =   10
      End
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Render"
      Height          =   255
      Left            =   3240
      TabIndex        =   8
      Top             =   4080
      Width           =   1215
   End
   Begin VB.PictureBox Picture2 
      AutoRedraw      =   -1  'True
      Height          =   3615
      Left            =   5040
      ScaleHeight     =   237
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   309
      TabIndex        =   7
      Top             =   120
      Width           =   4695
   End
   Begin VB.VScrollBar VScroll4 
      Height          =   2775
      Left            =   2640
      Max             =   -80
      Min             =   80
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   2760
      Width           =   255
   End
   Begin VB.VScrollBar VScroll3 
      Height          =   2775
      Left            =   1800
      Max             =   -80
      Min             =   80
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   2760
      Width           =   255
   End
   Begin VB.VScrollBar VScroll2 
      Height          =   2775
      Left            =   960
      Max             =   -80
      Min             =   80
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   2760
      Width           =   255
   End
   Begin VB.VScrollBar VScroll1 
      Height          =   2775
      Left            =   120
      Max             =   -80
      Min             =   80
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   2760
      Width           =   255
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Controls"
      Height          =   255
      Left            =   3240
      TabIndex        =   1
      Top             =   2760
      Width           =   1215
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      Height          =   2535
      Left            =   120
      ScaleHeight     =   165
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   317
      TabIndex        =   0
      Top             =   120
      Width           =   4815
   End
   Begin VB.Label Label1 
      Caption         =   "Cliccare il tasto Controls per fare apparire i punti di controllo della curva"
      Height          =   855
      Left            =   3120
      TabIndex        =   6
      Top             =   3120
      Width           =   1455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Bezier simple curves generator v 1.0
' Author: Andrea Ingegneri
' Copyright (c) 2000
' Special Thanks to Gianpaolo Ingegneri

Dim p1 As punto, p2 As punto, p3 As punto, p4 As punto
Dim curve1 As bezier, curve2 As bezier
Dim np, XRot, YRot
Dim superficie() As poligono

Private Sub Command1_Click()
'Picture1.PSet (p1.x, p1.y), RGB(0, 0, 0)
Picture1.PSet (p2.x, p2.y), RGB(255, 255, 255)
Picture1.PSet (p3.x, p3.y), RGB(255, 255, 255)
'Picture1.PSet (p4.x, p4.y), RGB(0, 0, 0)
End Sub

Private Sub Command2_Click()
Calculate3d precision1, precision2
RenderScene
End Sub

Private Sub Form_Load()
' Inizializziamo i punti
p1.x = 10: p1.y = 80
p4.x = 320: p4.y = 80
p2.x = 55: p2.y = 80
p3.x = 185: p3.y = 80
' Disegna la curva
precision1 = 10: precision2 = 10
Render
End Sub

Private Sub Render()
Picture1.Cls

' Calcola la prima equazione (Per l'asse x)
curve1 = calcbezier1(p1, p2, p3, p4)
' Calcola la prima equazione (Per l'asse y)
curve2 = calcbezier2(p1, p2, p3, p4)

For t = 0 To 1 Step 0.01
    ' x = a*(t^3) + b*(t^2) + c*t + d
    x = ((t ^ 3) * curve1.a) + ((t ^ 2) * curve1.b) + (t * curve1.c) + curve1.d
    ' y = a*(t^3) + b*(t^2) + c*t + d
    y = ((t ^ 3) * curve2.a) + ((t ^ 2) * curve2.b) + (t * curve2.c) + curve2.d
    ' Calcoliamo le coordinate del punto successivo
    xa = (((t + 0.01) ^ 3) * curve1.a) + (((t + 0.01) ^ 2) * curve1.b) + ((t + 0.01) * curve1.c) + curve1.d
    ya = (((t + 0.01) ^ 3) * curve2.a) + (((t + 0.01) ^ 2) * curve2.b) + ((t + 0.01) * curve2.c) + curve2.d
    ' Utilizziamo Line con i due punti, in questo modo la curva perde la sua puntinatura
    Picture1.Line (x, y)-(xa, ya), RGB(0, 0, 0)
    Picture1.Line (x, y + 1)-(xa, ya + 1), RGB(255, 0, 0)
Next
Picture1.Refresh
End Sub

Private Sub Calculate3d(ByVal precisione1, ByVal precisione2)
speed1 = 1 / precisione1
speed2 = 200 / precisione2
numpoligoni = (precisione1 * precisione2) + 100 ' per sicurezza :-)
ReDim superficie(numpoligoni)
np = 0

' Calcola la prima equazione (Per l'asse x)
curve1 = calcbezier1(p1, p2, p3, p4)
' Calcola la prima equazione (Per l'asse y)
curve2 = calcbezier2(p1, p2, p3, p4)

For t = 0 To 1 + 0.01 Step speed1
    ' x = a*(t^3) + b*(t^2) + c*t + d
    x = ((t ^ 3) * curve1.a) + ((t ^ 2) * curve1.b) + (t * curve1.c) + curve1.d
    ' y = a*(t^3) + b*(t^2) + c*t + d
    y = ((t ^ 3) * curve2.a) + ((t ^ 2) * curve2.b) + (t * curve2.c) + curve2.d
    ' Calcoliamo le coordinate del punto successivo
    xa = (((t + speed1) ^ 3) * curve1.a) + (((t + speed1) ^ 2) * curve1.b) + ((t + speed1) * curve1.c) + curve1.d
    ya = (((t + speed1) ^ 3) * curve2.a) + (((t + speed1) ^ 2) * curve2.b) + ((t + speed1) * curve2.c) + curve2.d
    ' Utilizziamo Line con i due punti, in questo modo la curva perde la sua puntinatura
    For z = 0 To 200 Step speed2
        superficie(np).p1.x = x - 160
        superficie(np).p1.y = y - 120
        superficie(np).p1.z = z - 100
        superficie(np).p2.x = xa - 160
        superficie(np).p2.y = ya - 120
        superficie(np).p2.z = z - 100
        superficie(np).p3.x = x - 160
        superficie(np).p3.y = y - 120
        superficie(np).p3.z = (z - 100) + speed2
        superficie(np).p4.x = xa - 160
        superficie(np).p4.y = ya - 120
        superficie(np).p4.z = (z - 100) + speed2
        np = np + 1
    Next
Next
End Sub

Private Sub RenderScene()
Picture2.Cls
    rwy2 = ((XRot + 90) * 3.14) / 180
    rwx2 = ((YRot + 90) * 3.14) / 180
    rwz2 = ((ZRot + 90) * 3.14) / 180
    srwy = Sin(rwy2)
    crwy = Cos(rwy2)
    srwx = Sin(rwx2)
    crwx = Cos(rwx2)
    srwz = Sin(rwz2)
    crwz = Cos(rwz2)
For n = 0 To np
ex1 = superficie(n).p1.x * 0.5
ey1 = superficie(n).p1.y * 0.5
ez1 = superficie(n).p1.z * 0.5
ex2 = superficie(n).p2.x * 0.5
ey2 = superficie(n).p2.y * 0.5
ez2 = superficie(n).p2.z * 0.5
ex3 = superficie(n).p3.x * 0.5
ey3 = superficie(n).p3.y * 0.5
ez3 = superficie(n).p3.z * 0.5
ex4 = superficie(n).p4.x * 0.5
ey4 = superficie(n).p4.y * 0.5
ez4 = superficie(n).p4.z * 0.5
        
    lx1 = ((ex1 * srwy) - (ez1 * crwy))
    lz1 = ((ez1 * srwy) + (ex1 * crwy))
    ly1 = ey1
    wz1 = lz1
    wx1 = ((lx1 * srwz) - (ly1 * crwz))
    wy1 = ((ly1 * srwz) + (lx1 * crwz))
    x1p = wx1
    y1p = ((wy1 * srwx) - (wz1 * crwx))
    z1p = ((wz1 * srwx) + (wy1 * crwx))

    lx2 = ((ex2 * srwy) - (ez2 * crwy))
    lz2 = ((ez2 * srwy) + (ex2 * crwy))
    ly2 = ey2
    wz2 = lz2
    wx2 = ((lx2 * srwz) - (ly2 * crwz))
    wy2 = ((ly2 * srwz) + (lx2 * crwz))
    x2p = wx2
    y2p = ((wy2 * srwx) - (wz2 * crwx))
    z2p = ((wz2 * srwx) + (wy2 * crwx))

    lx3 = ((ex3 * srwy) - (ez3 * crwy))
    lz3 = ((ez3 * srwy) + (ex3 * crwy))
    ly3 = ey3
    wz3 = lz3
    wx3 = ((lx3 * srwz) - (ly3 * crwz))
    wy3 = ((ly3 * srwz) + (lx3 * crwz))
    x3p = wx3
    y3p = ((wy3 * srwx) - (wz3 * crwx))
    z3p = ((wz3 * srwx) + (wy3 * crwx))

    lx4 = ((ex4 * srwy) - (ez4 * crwy))
    lz4 = ((ez4 * srwy) + (ex4 * crwy))
    ly4 = ey4
    wz4 = lz4
    wx4 = ((lx4 * srwz) - (ly4 * crwz))
    wy4 = ((ly4 * srwz) + (lx4 * crwz))
    x4p = wx4
    y4p = ((wy4 * srwx) - (wz4 * crwx))
    z4p = ((wz4 * srwx) + (wy4 * crwx))

px1 = ((x1p * 256) / (z1p + 256)) + 160
py1 = ((y1p * 256) / (z1p + 256)) + 120
px2 = ((x2p * 256) / (z2p + 256)) + 160
py2 = ((y2p * 256) / (z2p + 256)) + 120
px3 = ((x3p * 256) / (z3p + 256)) + 160
py3 = ((y3p * 256) / (z3p + 256)) + 120
px4 = ((x4p * 256) / (z4p + 256)) + 160
py4 = ((y4p * 256) / (z4p + 256)) + 120

Picture2.Line (px1, py1)-(px2, py2), 0
Picture2.Line (px2, py2)-(px4, py4), 0
Picture2.Line (px4, py4)-(px3, py3), 0
Picture2.Line (px3, py3)-(px1, py1), 0
Next
Picture2.Refresh
End Sub

Private Function calcbezier1(p0 As punto, p1 As punto, p2 As punto, p3 As punto) As bezier
Dim curve As bezier

curve.d = p0.x
curve.c = 3 * (p1.x - p0.x)
curve.b = 3 * (p2.x - p1.x) - curve.c
curve.a = p3.x - p0.x - curve.c - curve.b

calcbezier1 = curve

End Function

Private Function calcbezier2(p0 As punto, p1 As punto, p2 As punto, p3 As punto) As bezier
Dim curve As bezier

curve.d = p0.y
curve.c = 3 * (p1.y - p0.y)
curve.b = 3 * (p2.y - p1.y) - curve.c
curve.a = p3.y - p0.y - curve.c - curve.b

calcbezier2 = curve

End Function

Private Sub Slider1_Scroll()
precision1 = Slider1.Value
Calculate3d precision1, precision2
RenderScene
End Sub

Private Sub Slider2_Scroll()
precision2 = Slider2.Value
Calculate3d precision1, precision2
RenderScene
End Sub

Private Sub VScroll1_Scroll()
p1.y = 80 - VScroll1.Value
Render
Calculate3d precision1, precision2
RenderScene
End Sub

Private Sub VScroll2_Scroll()
p2.y = 80 - VScroll2.Value
Render
Calculate3d precision1, precision2
RenderScene
End Sub

Private Sub VScroll3_Scroll()
p3.y = 80 - VScroll3.Value
Render
Calculate3d precision1, precision2
RenderScene
End Sub

Private Sub VScroll4_Scroll()
p4.y = 80 - VScroll4.Value
Render
Calculate3d precision1, precision2
RenderScene
End Sub

Private Sub VScroll1_change()
p1.y = 80 - VScroll1.Value
Render
Calculate3d precision1, precision2
RenderScene
End Sub

Private Sub VScroll2_change()
p2.y = 80 - VScroll2.Value
Render
Calculate3d precision1, precision2
RenderScene
End Sub

Private Sub VScroll3_change()
p3.y = 80 - VScroll3.Value
Render
Calculate3d precision1, precision2
RenderScene
End Sub

Private Sub VScroll4_change()
p4.y = 80 - VScroll4.Value
Render
Calculate3d precision1, precision2
RenderScene
End Sub

Private Sub VScroll5_Change()
YRot = VScroll5.Value
Render
Calculate3d precision1, precision2
RenderScene
End Sub

Private Sub VScroll5_Scroll()
YRot = VScroll5.Value
Render
Calculate3d precision1, precision2
RenderScene
End Sub

Private Sub HScroll1_Change()
XRot = HScroll1.Value
Render
Calculate3d precision1, precision2
RenderScene
End Sub

Private Sub HScroll1_Scroll()
XRot = HScroll1.Value
Render
Calculate3d precision1, precision2
RenderScene
End Sub
