program tred;
uses crt,graph;
const max=10;ox=320;oy=240;
type    punti = array[1..max,1..3] of real;
    adiacenze = array[1..max,1..max] of boolean;
var         P : punti;
            A : adiacenze;
          n,m : integer; { numero di  punti, numero di adiacenze }
   alpha,beta : real;
            k : integer;
           ch : char;

Procedure inizializza;
var g,d:integer;
begin
   d:=detect;
   initgraph(d,g,'c:\tp\bgi');
   line(ox,oy,ox+round(cos(alpha)*k*20),oy-round(sin(alpha)*k*20)); { x,  legato a alpha }
   line(ox,oy,ox,oy-k*20);   { z, fisso }
   line(ox,oy,ox-round(cos(beta)*k*20),oy-round(sin(beta)*k*20)); {  legata al valore di beta }
end;

Procedure leggip(var mat:punti);
var i:integer;
begin
     clrscr;
     writeln;
     write('N. punti --> ');
     readln(n);
     for i:=1 to n do
     begin
          writeln;
          writeln('Punto ',i);
          write(' x --> ');
          readln(mat[i,1]);
          write(' y --> ');
          readln(mat[i,2]);
          write(' z --> ');
          readln(mat[i,3]);
     end;
end;

procedure leggia(var mat:adiacenze);
var i,j,uno,due:integer;
begin
     clrscr;
     writeln;
     write('N. adiacenze --> ');
     readln(m);
     { inizializza matrice delle adiacenze }
     for i:=1 to n do
        for j:=i+1 to n do
           mat[i,j]:=false;
     for i:=1 to m do
     begin
          writeln;
          writeln('Adiacenza',i);
          write(' estremo 1 --> ');
          readln(uno);
          write(' estremo 2 --> ');
          readln(due);
          mat[uno,due]:=true;
          mat[due,uno]:=true; { la matrice  simmetrica }
     end;
end;

Procedure trasforma(xx,yy,zz:real; var uu,vv:real);
begin
    uu:=(xx*cos(alpha)-yy*cos(beta))*k;
    vv:=(xx*sin(alpha)+yy*sin(beta)+zz)*k;
end;

Procedure putp(uu,vv:real);
var xscr,yscr:integer;
begin
    setcolor(yellow);
    xscr:=round(uu+ox);
    yscr:=round(oy-vv);
    circle(xscr,yscr,2);
end;

Procedure putl(uu1,vv1,uu2,vv2:real);
var xscr1,yscr1,xscr2,yscr2:integer;
begin
    setcolor(blue);
    xscr1:=round(uu1+ox);
    yscr1:=round(oy-vv1);
    xscr2:=round(uu2+ox);
    yscr2:=round(oy-vv2);
    line(xscr1,yscr1,xscr2,yscr2);
end;

Procedure puts(mat1 : punti; mat2 : adiacenze);
var     i,j:integer;
  u,v,u2,v2:real;
begin
     for i:=1 to n do
        begin
             trasforma(mat1[i,1],mat1[i,2],mat1[i,3],u,v);
             putp(u,v);
        end;
     for i:=1 to n do
        for j:=i+1 to n do
          if mat2[i,j] then
             begin
                 trasforma(mat1[i,1],mat1[i,2],mat1[i,3],u,v);
                 trasforma(mat1[j,1],mat1[j,2],mat1[j,3],u2,v2);
                 putl(u,v,u2,v2);
             end
end;

Procedure ruota_x(var mat:punti);
var y,z,teta : real;
           i : integer;
Begin
     teta:=0.314;
     For i:=1 to n do
     Begin
        y:=mat[i,2]*cos(teta)+mat[i,3]*sin(teta);
        z:=mat[i,2]*(-sin(teta))+mat[i,3]*cos(teta);
        mat[i,2]:=y;
        mat[i,3]:=z;
     End;
End ;

Procedure ruota_z(var mat:punti);
var x,y,teta : real;
           i : integer;
Begin
     teta:=0.314;
     For i:=1 to n do
     Begin
        x:=mat[i,1]*cos(teta)+mat[i,2]*sin(teta);
        y:=mat[i,1]*(-sin(teta))+mat[i,2]*cos(teta);
        mat[i,1]:=x;
        mat[i,2]:=y;
     End;
End ;

Procedure ruota_y(var mat:punti);
var x,z,teta : real;
           i : integer;
Begin
     teta:=0.314;
     For i:=1 to n do
     Begin
        x:=mat[i,1]*cos(teta)+mat[i,3]*(-sin(teta));
        z:=mat[i,1]*sin(teta)+mat[i,3]*cos(teta);
        mat[i,1]:=x;
        mat[i,3]:=z;
     End;
End ;

Begin { Main }
     leggip(P);
     leggia(A);
     k:=10;
     alpha:=0; { angolo tra punto di vista e asse x }
     beta:=-0.785; { angolo tra punto di vista e asse y }
     repeat
       inizializza;
       puts(P,A);
       ch:=readkey;
       case ch of
       '-' : k:=k-2;
       '+' : k:=k+2;
       '/' : alpha:=alpha+0.1;
       '*' : alpha:=alpha-0.1;
       '.' : beta:=beta+0.1;
       ',' : beta:=beta-0.1;
       'x' : ruota_x(P);
       'y' : ruota_y(P);
       'z' : ruota_z(P);
       end
     until ch='#';
End.
